#!/bin/bash

#
# Set to exit immediately on a non-zero return code from any command
#
set -e

PUPPET_TMP_DIR=/var/tmp/backup/puppet

if [ ! -d ${PUPPET_TMP_DIR} ]; then
    mkdir -p ${PUPPET_TMP_DIR}
fi
chmod 755 ${PUPPET_TMP_DIR}

rm -rf ${PUPPET_TMP_DIR}/*

if [ -d /etc/puppetlabs/puppet/devices ]; then
    cp -r /etc/puppetlabs/puppet/devices ${PUPPET_TMP_DIR}
    chmod -R 775 ${PUPPET_TMP_DIR}/devices
else
    mkdir ${PUPPET_TMP_DIR}/devices
fi

mkdir ${PUPPET_TMP_DIR}/pe-puppet
chmod -R 775 ${PUPPET_TMP_DIR}/pe-puppet

cp -r /etc/puppetlabs/puppet/manifests ${PUPPET_TMP_DIR}
cp -r /var/lib/puppet ${PUPPET_TMP_DIR}

cp -pr /var/opt/lib/pe-puppet/devices ${PUPPET_TMP_DIR}/pe-puppet
cp -pr /var/opt/lib/pe-puppet/reports ${PUPPET_TMP_DIR}/pe-puppet
cp -pr /var/opt/lib/pe-puppet/yaml ${PUPPET_TMP_DIR}/pe-puppet
cp -pr /var/opt/lib/pe-puppet/ssl ${PUPPET_TMP_DIR}/pe-puppet

# Backup Carbon Data to the pe-puppet directory for backup
cp -pr /var/lib/carbon ${PUPPET_TMP_DIR}/pe-puppet

# Backup ntp client settings
cp -pr /etc/ntp.conf ${PUPPET_TMP_DIR}/pe-puppet
cp -pr /etc/ntp/step-tickers ${PUPPET_TMP_DIR}/pe-puppet

# Backup TimeZone info
cp -pr /etc/sysconfig/clock ${PUPPET_TMP_DIR}/pe-puppet

# Backup AddOn Modules
if [ -d /opt/Dell/ASM/modules ]; then
    mkdir ${PUPPET_TMP_DIR}/pe-puppet/ASM
    cp -pr /opt/Dell/ASM/modules ${PUPPET_TMP_DIR}/pe-puppet/ASM
fi

cd ${PUPPET_TMP_DIR}/pe-puppet
tar cfp ${PUPPET_TMP_DIR}/pe-puppet.tar *


# Temp Debug to view pe-puppet.tar file contents
# cp ${PUPPET_TMP_DIR}/pe-puppet.tar ~/pe-puppet.tar
rm -rf ${PUPPET_TMP_DIR}/pe-puppet

cp -pr /opt/Dell/ASM/device ${PUPPET_TMP_DIR}
cp -pr /opt/Dell/ASM/deployments ${PUPPET_TMP_DIR}

cd ${PUPPET_TMP_DIR}/deployments
if [ "$(ls -A .)" ]; then
   tar cfp ${PUPPET_TMP_DIR}/deployments.tar *
fi

rm -rf ${PUPPET_TMP_DIR}/deployments

exit 0
