#!/bin/bash

LOGS_BASE_DIR=/var/tmp
LOGS_DIR=troubleshooting_logs
LOGS_FULL_DIR=$LOGS_BASE_DIR/$LOGS_DIR

LOGS_ZIP_DIR=$LOGS_BASE_DIR/troubleshooting_logs_zip

# Remove any previous files in our tmp logs dir
rm -rf $LOGS_FULL_DIR
mkdir $LOGS_FULL_DIR

# Remove any previously generated logs from staging area
rm -rf $LOGS_ZIP_DIR
mkdir $LOGS_ZIP_DIR

# Copy various logs to our tmp logs dir
mkdir $LOGS_FULL_DIR/DB_Logs
cp -ar /opt/Dell/asmdb/data/pg_log/* $LOGS_FULL_DIR/DB_Logs
mkdir $LOGS_FULL_DIR/ASM_logs
cp -ar /opt/Dell/ASM/logs/* $LOGS_FULL_DIR/ASM_logs
mkdir $LOGS_FULL_DIR/ASMDeploy_logs
cp -ar --parents /opt/Dell/ASM/deployments/* $LOGS_FULL_DIR/ASMDeploy_logs
mkdir $LOGS_FULL_DIR/Puppet_logs
cp -ar /var/log/puppet/* $LOGS_FULL_DIR/Puppet_logs
mkdir $LOGS_FULL_DIR/PuppetDB_logs
cp -ar /var/log/puppetdb/* $LOGS_FULL_DIR/PuppetDB_logs
mkdir $LOGS_FULL_DIR/RazorServer_logs
cp -ar /var/log/razor/* $LOGS_FULL_DIR/RazorServer_logs
mkdir $LOGS_FULL_DIR/Device_Inventory_logs
cp -ar /opt/Dell/ASM/device/* $LOGS_FULL_DIR/Device_Inventory_logs
mkdir $LOGS_FULL_DIR/DeviceFacts
cp -ar /opt/Dell/ASM/cache/* $LOGS_FULL_DIR/DeviceFacts

# zip up the collected log files from tmp logs dir into staging area
cd $LOGS_BASE_DIR
/usr/bin/zip -r $LOGS_ZIP_DIR/Dell_ASM_Logs.zip $LOGS_DIR
chmod o+r $LOGS_ZIP_DIR/Dell_ASM_Logs.zip

echo Success
exit 0
